--- pristine_ast_trunk/pbx.c	2006-06-13 09:42:42.000000000 -0500
+++ digium_trunk/pbx.c	2006-06-13 09:40:58.000000000 -0500
@@ -1396,18 +1396,26 @@
 	return args;
 }
 
-int ast_func_read(struct ast_channel *chan, char *function, char *workspace, size_t len)
+int ast_func_read(struct ast_channel *chan, char *func, char *workspace, size_t len)
 {
+	if (!func || !strlen(func))
+		return -1;
+	
+	char* function = malloc(strlen(func)+1);
+	ast_copy_string(function, func, strlen(func)+1);
 	char *args = func_args(function);
+   int ret = -1;	
 	struct ast_custom_function *acfptr = ast_custom_function_find(function);
-
+	
 	if (acfptr == NULL)
 		ast_log(LOG_ERROR, "Function %s not registered\n", function);
 	else if (!acfptr->read)
 		ast_log(LOG_ERROR, "Function %s cannot be read\n", function);
-	else
-		return acfptr->read(chan, function, args, workspace, len);
-	return -1;
+	else 
+		ret = acfptr->read(chan, function, args, workspace, len);
+	
+	free(function);
+	return ret;
 }
 
 int ast_func_write(struct ast_channel *chan, char *function, const char *value)
